Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.caucho.server.http
Class AbstractRequest

    java.lang.Object
      |
      +--com.caucho.server.http.AbstractRequest

All Implemented Interfaces:
  CauchoRequest, HttpServletRequest, SecurityContextProvider, ServletRequest

Direct Known Subclasses:
  Request

public abstract class AbstractRequest
extends java.lang.Object
implements CauchoRequest, SecurityContextProvider

Abstract request implementing methods common to the different request implementations.

Field Summary
`protected com.caucho.server.http.CacheInvocation` | `cache`
`protected QDate` | `calendar`
`static java.lang.String` | `CONTEXT_PATH`
`static java.lang.String` | `ERROR_URI`
`static java.lang.String` | `EXCEPTION`
`protected com.caucho.server.http.Invocation` | `invocation`
`static java.lang.String` | `JSP_EXCEPTION`
`static java.lang.String` | `MESSAGE`
`static java.lang.String` | `PATH_INFO`
`static java.lang.String` | `QUERY_STRING`
`static java.lang.String` | `REQUEST_URI`
`static java.lang.String` | `SERVLET_PATH`
`static java.lang.String` | `STATUS_CODE`

Fields inherited from interface javax.servlet.http.HttpServletRequest
`BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

Constructor Summary
`AbstractRequest()`

Method Summary
`boolean` | `authenticate()`
`protected com.caucho.http.session.SessionImpl` | `createSession(boolean create, boolean hasOldSession)` Returns the current session.
`protected void` | `finish()`
`protected void` | `finishSession()`
`abstract java.lang.Object` | `getAttribute(java.lang.String name)` Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.
`abstract java.util.Enumeration` | `getAttributeNames()` Returns an `Enumeration` containing the names of the attributes available to this request.
`java.lang.String` | `getAuthType()` Gets the authorization type
`CauchoApplication` | `getCauchoApplication()`
`java.lang.String` | `getChain(java.lang.String contentType)`
`abstract java.lang.String` | `getCharacterEncoding()` Returns the name of the character encoding used in the body of this request.
`abstract int` | `getContentLength()` Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
`abstract java.lang.String` | `getContentType()` Returns the MIME type of the body of the request, or `null` if the type is not known.
`abstract java.lang.String` | `getContextPath()` Returns the portion of the request URI that indicates the context of the request.
`abstract Cookie` | `getCookie(java.lang.String name)`
`abstract Cookie[]` | `getCookies()` Returns an array containing all of the `Cookie` objects the client sent with this request.
`abstract long` | `getDate()`
`long` | `getDateHeader(java.lang.String key)` Returns a header interpreted as a date.
`abstract java.lang.String` | `getHeader(java.lang.String key)` Returns the value of the specified request header as a `String`.
`abstract java.util.Enumeration` | `getHeaderNames()` Returns an enumeration of all the header names this request contains.
`abstract java.util.Enumeration` | `getHeaders(java.lang.String name)` Returns all the values of the specified request header as an `Enumeration` of `String` objects.
`abstract ServletInputStream` | `getInputStream()` Retrieves the body of the request as binary data using a `ServletInputStream`.
`int` | `getIntHeader(java.lang.String key)` Returns the value of the specified request header as an `int`.
`abstract java.util.Locale` | `getLocale()` Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header.
`abstract java.util.Enumeration` | `getLocales()` Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.
`java.lang.String` | `getMedia()`
`abstract java.lang.String` | `getMethod()` Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
`CharSegment` | `getMethodBuffer()`
`java.lang.String` | `getPageContextPath()`
`java.lang.String` | `getPagePathInfo()` Returns the path-info for the current page, i.e.
`java.lang.String` | `getPageQueryString()` Returns the query-string for the current page, i.e.
`java.lang.String` | `getPageServletPath()` Returns the servlet-path for the current page, i.e.
`java.lang.String` | `getPageURI()`
`abstract java.lang.String` | `getParameter(java.lang.String name)` Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist.
`abstract java.util.Enumeration` | `getParameterNames()` Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request.
`abstract java.lang.String[]` | `getParameterValues(java.lang.String name)` Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.
`abstract java.lang.String` | `getPathInfo()` Returns any extra path information associated with the URL the client sent when it made this request.
`abstract java.lang.String` | `getPathTranslated()` Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
`abstract java.lang.String` | `getProtocol()` Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1.
`abstract java.lang.String` | `getQueryString()` Returns the query string that is contained in the request URL after the path.
`abstract java.io.BufferedReader` | `getReader()` Retrieves the body of the request as character data using a `BufferedReader`.
`abstract java.lang.String` | `getRealPath(java.lang.String path)` Deprecated.
`abstract java.lang.String` | `getRemoteAddr()` Returns the Internet Protocol (IP) address of the client that sent the request.
`abstract java.lang.String` | `getRemoteHost()` Returns the fully qualified name of the client that sent the request, or the IP address of the client if the name cannot be determined.
`java.lang.String` | `getRemoteUser()` Gets the remote user from the authorization type
`java.lang.String` | `getRemoteUser(boolean create)` Internal logging return to get the remote user.
`int` | `getRequestDepth(int depth)` Returns the depth of the request calls.
`RequestDispatcher` | `getRequestDispatcher(java.lang.String path)` Returns a request dispatcher relative to the current request.
`abstract java.lang.String` | `getRequestedSessionId()` Returns the session ID specified by the client.
`abstract java.lang.String` | `getRequestURI()` Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
`java.lang.StringBuffer` | `getRequestURL()` Returns the URL for the request
`abstract java.lang.String` | `getScheme()` Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`.
`abstract java.lang.String` | `getServerName()` Returns the host name of the server that received the request.
`abstract int` | `getServerPort()` Returns the port number on which this request was received.
`abstract java.lang.String` | `getServletPath()` Returns the part of this request's URL that calls the servlet.
`HttpSession` | `getSession()` Returns the current session, creating one if necessary.
`abstract HttpSession` | `getSession(boolean create)` Returns the current session.
`abstract int` | `getSessionGroup()`
`abstract ReadStream` | `getStream()`
`java.security.Principal` | `getUserPrincipal()` Returns the Principal representing the logged in user.
`abstract boolean` | `isRequestedSessionIdFromCookie()` Checks whether the requested session ID came in as a cookie.
`boolean` | `isRequestedSessionIdFromUrl()` Deprecated.
`abstract boolean` | `isRequestedSessionIdFromURL()` Checks whether the requested session ID came in as part of the request URL.
`abstract boolean` | `isRequestedSessionIdValid()` Checks whether the requested session ID is still valid.
`abstract boolean` | `isSecure()` Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
`boolean` | `isUserInRole(java.lang.String role)` Returns true if the user represented by the current request plays the named role.
`void` | `logoutUserPrincipal()` Clear the principal from the request object.
`abstract void` | `removeAttribute(java.lang.String name)` Removes an attribute from this request.
`abstract void` | `setAttribute(java.lang.String name, java.lang.Object value)` Stores an attribute in this request.
`protected void` | `setHasCookie()` Set when the page actually has a cookie.
`void` | `setHeader(java.lang.String key, java.lang.String value)`
`protected void` | `setVaryCookie(java.lang.String cookie)` Called if the page depends on a cookie.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.servlet.ServletRequest
`getParameterMap, setCharacterEncoding`

Field Detail

### REQUEST_URI

    public static java.lang.String REQUEST_URI

### CONTEXT_PATH

    public static java.lang.String CONTEXT_PATH

### SERVLET_PATH

    public static java.lang.String SERVLET_PATH

### PATH_INFO

    public static java.lang.String PATH_INFO

### QUERY_STRING

    public static java.lang.String QUERY_STRING

### EXCEPTION

    public static java.lang.String EXCEPTION

### STATUS_CODE

    public static java.lang.String STATUS_CODE

### MESSAGE

    public static java.lang.String MESSAGE

### ERROR_URI

    public static java.lang.String ERROR_URI

### JSP_EXCEPTION

    public static java.lang.String JSP_EXCEPTION

### calendar

    protected QDate calendar

### invocation

    protected com.caucho.server.http.Invocation invocation

### cache

    protected com.caucho.server.http.CacheInvocation cache

Constructor Detail

### AbstractRequest

    public AbstractRequest()

Method Detail

### getStream

    public abstract ReadStream getStream()
                                  throws java.io.IOException

  Specified by:
    `getStream` in interface `CauchoRequest`

### getRequestDepth

    public int getRequestDepth(int depth)

  Returns the depth of the request calls.
  Specified by:
    `getRequestDepth` in interface `CauchoRequest`

### getDate

    public abstract long getDate()

  Specified by:
    `getDate` in interface `CauchoRequest`

### getInputStream

    public abstract ServletInputStream getInputStream()
                                               throws java.io.IOException

  Description copied from interface: `ServletRequest`
  Retrieves the body of the request as binary data using a `ServletInputStream`. Either this method or `ServletRequest.getReader()` may be called to read the body, not both.
  Specified by:
    `getInputStream` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `ServletInputStream` object containing the body of the request
  Throws:
    `java.lang.IllegalStateException` - if the `ServletRequest.getReader()` method has already been called for this request
    `java.io.IOException` - if an input or output exception occurred

### getReader

    public abstract java.io.BufferedReader getReader()
                                              throws java.io.IOException

  Description copied from interface: `ServletRequest`
  Retrieves the body of the request as character data using a `BufferedReader`. The reader translates the character data according to the character encoding used on the body. Either this method or `ServletRequest.getReader()` may be called to read the body, not both.
  Specified by:
    `getReader` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `BufferedReader` containing the body of the request
  Throws:
    `java.io.UnsupportedEncodingException` - if the character set encoding used is not supported and the text cannot be decoded
    `java.lang.IllegalStateException` - if `ServletRequest.getInputStream()` method has been called on this request
    `java.io.IOException` - if an input or output exception occurred
  See Also:
    `ServletRequest.getInputStream()`

### getServerName

    public abstract java.lang.String getServerName()

  Description copied from interface: `ServletRequest`
  Returns the host name of the server that received the request. For HTTP servlets, same as the value of the CGI variable `SERVER_NAME`.
  Specified by:
    `getServerName` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `String` containing the name of the server to which the request was sent

### getServerPort

    public abstract int getServerPort()

  Description copied from interface: `ServletRequest`
  Returns the port number on which this request was received. For HTTP servlets, same as the value of the CGI variable `SERVER_PORT`.
  Specified by:
    `getServerPort` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    an integer specifying the port number

### getRemoteAddr

    public abstract java.lang.String getRemoteAddr()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) address of the client that sent the request. For HTTP servlets, same as the value of the CGI variable `REMOTE_ADDR`.
  Specified by:
    `getRemoteAddr` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `String` containing the IP address of the client that sent the request

### getRemoteHost

    public abstract java.lang.String getRemoteHost()

  Description copied from interface: `ServletRequest`
  Returns the fully qualified name of the client that sent the request, or the IP address of the client if the name cannot be determined. For HTTP servlets, same as the value of the CGI variable `REMOTE_HOST`.
  Specified by:
    `getRemoteHost` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `String` containing the fully qualified name of the client

### getScheme

    public abstract java.lang.String getScheme()

  Description copied from interface: `ServletRequest`
  Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`. Different schemes have different rules for constructing URLs, as noted in RFC 1738.
  Specified by:
    `getScheme` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `String` containing the name of the scheme used to make this request

### getMethodBuffer

    public CharSegment getMethodBuffer()

### getMethod

    public abstract java.lang.String getMethod()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.
  Specified by:
    `getMethod` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String` specifying the name of the method with which this request was made

### getProtocol

    public abstract java.lang.String getProtocol()

  Description copied from interface: `ServletRequest`
  Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1. For HTTP servlets, the value returned is the same as the value of the CGI variable `SERVER_PROTOCOL`.
  Specified by:
    `getProtocol` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `String` containing the protocol name and version number

### getRequestURI

    public abstract java.lang.String getRequestURI()

  Description copied from interface: `HttpServletRequest`
  Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String. For example:

  > First line of HTTP request |  | Returned Value
  > --- | --- | ---
  > POST /some/path.html HTTP/1.1 |  | /some/path.html
  > GET http://foo.bar/a.html HTTP/1.0 |  | /a.html
  > HEAD /xyz?a=b HTTP/1.1 |  | /xyz

  To reconstruct an URL with a scheme and host, use `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`.

  Specified by:
    `getRequestURI` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String` containing the part of the URL from the protocol name up to the query string
  See Also:
    `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`

### getPageURI

    public java.lang.String getPageURI()

  Specified by:
    `getPageURI` in interface `CauchoRequest`

### getRequestURL

    public java.lang.StringBuffer getRequestURL()

  Returns the URL for the request
  Specified by:
    `getRequestURL` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `StringBuffer` object containing the reconstructed URL

### getContextPath

    public abstract java.lang.String getContextPath()

  Description copied from interface: `HttpServletRequest`
  Returns the portion of the request URI that indicates the context of the request. The context path always comes first in a request URI. The path starts with a "/" character but does not end with a "/" character. For servlets in the default (root) context, this method returns "". The container does not decode this string.
  Specified by:
    `getContextPath` in interface `CauchoRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String` specifying the portion of the request URI that indicates the context of the request

### getPageContextPath

    public java.lang.String getPageContextPath()

  Specified by:
    `getPageContextPath` in interface `CauchoRequest`

### getServletPath

    public abstract java.lang.String getServletPath()

  Description copied from interface: `HttpServletRequest`
  Returns the part of this request's URL that calls the servlet. This includes either the servlet name or a path to the servlet, but does not include any extra path information or a query string. Same as the value of the CGI variable SCRIPT_NAME.
  Specified by:
    `getServletPath` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String` containing the name or path of the servlet being called, as specified in the request URL, decoded.

### getPageServletPath

    public java.lang.String getPageServletPath()

  Returns the servlet-path for the current page, i.e. this will return the url of the include page, not the original request.
  Specified by:
    `getPageServletPath` in interface `CauchoRequest`

### getPathInfo

    public abstract java.lang.String getPathInfo()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string. This method returns `null` if there was no extra path information.

  Same as the value of the CGI variable PATH_INFO.

  Specified by:
    `getPathInfo` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String`, decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

### getPagePathInfo

    public java.lang.String getPagePathInfo()

  Returns the path-info for the current page, i.e. this will return the url of the include page, not the original request.
  Specified by:
    `getPagePathInfo` in interface `CauchoRequest`

### getQueryString

    public abstract java.lang.String getQueryString()

  Description copied from interface: `HttpServletRequest`
  Returns the query string that is contained in the request URL after the path. This method returns `null` if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.
  Specified by:
    `getQueryString` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

### getPageQueryString

    public java.lang.String getPageQueryString()

  Returns the query-string for the current page, i.e. this will return the url of the include page, not the original request.
  Specified by:
    `getPageQueryString` in interface `CauchoRequest`

### getContentLength

    public abstract int getContentLength()

  Description copied from interface: `ServletRequest`
  Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.
  Specified by:
    `getContentLength` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    an integer containing the length of the request body or -1 if the length is not known

### getContentType

    public abstract java.lang.String getContentType()

  Description copied from interface: `ServletRequest`
  Returns the MIME type of the body of the request, or `null` if the type is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_TYPE.
  Specified by:
    `getContentType` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `String` containing the name of the MIME type of the request, or -1 if the type is not known

### getCharacterEncoding

    public abstract java.lang.String getCharacterEncoding()

  Description copied from interface: `ServletRequest`
  Returns the name of the character encoding used in the body of this request. This method returns `null` if the request does not specify a character encoding
  Specified by:
    `getCharacterEncoding` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a `String` containing the name of the chararacter encoding, or `null` if the request does not specify a character encoding

### getHeader

    public abstract java.lang.String getHeader(java.lang.String key)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `String`. If the request did not include a header of the specified name, this method returns `null`. The header name is case insensitive. You can use this method with any request header.
  Specified by:
    `getHeader` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

### setHeader

    public void setHeader(java.lang.String key,
                          java.lang.String value)

  Specified by:
    `setHeader` in interface `CauchoRequest`

### getCauchoApplication

    public CauchoApplication getCauchoApplication()

  Specified by:
    `getCauchoApplication` in interface `CauchoRequest`

### getIntHeader

    public int getIntHeader(java.lang.String key)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as an `int`. If the request does not have a header of the specified name, this method returns -1. If the header cannot be converted to an integer, this method throws a `NumberFormatException`.

  The header name is case insensitive.

  Specified by:
    `getIntHeader` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of a request header
  Returns:
    an integer expressing the value of the request header or -1 if the request doesn't have a header of this name
  Throws:
    `java.lang.NumberFormatException` - If the header value can't be converted to an `int`

### getDateHeader

    public long getDateHeader(java.lang.String key)

  Returns a header interpreted as a date.
  Specified by:
    `getDateHeader` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the header
  Returns:
    a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the reqest
  Throws:
    `java.lang.IllegalArgumentException` - If the header value can't be converted to a date

### setVaryCookie

    protected void setVaryCookie(java.lang.String cookie)

  Called if the page depends on a cookie. If the cookie is null, then the page depends on all cookies.
  Parameters:
    `cookie` - the cookie the page depends on.

### setHasCookie

    protected void setHasCookie()

  Set when the page actually has a cookie.

### getSession

    public abstract HttpSession getSession(boolean create)

  Returns the current session.
  Specified by:
    `getSession` in interface `HttpServletRequest`
  Parameters:
    `create` - if true and the session doesn't exist, create a new session

### getSession

    public HttpSession getSession()

  Returns the current session, creating one if necessary.
  Specified by:
    `getSession` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    the `HttpSession` associated with this request
  See Also:
    `HttpServletRequest.getSession(boolean)`

### createSession

    protected com.caucho.http.session.SessionImpl createSession(boolean create,
                                                                boolean hasOldSession)

  Returns the current session.
  Parameters:
    `create` - true if a new session should be created
  Returns:
    the current session

### getSessionGroup

    public abstract int getSessionGroup()

### getRequestedSessionId

    public abstract java.lang.String getRequestedSessionId()

  Description copied from interface: `HttpServletRequest`
  Returns the session ID specified by the client. This may not be the same as the ID of the actual session in use. For example, if the request specified an old (expired) session ID and the server has started a new session, this method gets a new session with a new ID. If the request did not specify a session ID, this method returns `null`.
  Specified by:
    `getRequestedSessionId` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String` specifying the session ID, or `null` if the request did not specify a session ID
  See Also:
    `HttpServletRequest.isRequestedSessionIdValid()`

### isRequestedSessionIdValid

    public abstract boolean isRequestedSessionIdValid()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID is still valid.
  Specified by:
    `isRequestedSessionIdValid` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    `true` if this request has an id for a valid session in the current session context; `false` otherwise
  See Also:
    `HttpServletRequest.getRequestedSessionId()`, `HttpServletRequest.getSession(boolean)`, `HttpSessionContext`

### isRequestedSessionIdFromCookie

    public abstract boolean isRequestedSessionIdFromCookie()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID came in as a cookie.
  Specified by:
    `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    `true` if the session ID came in as a cookie; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromURL

    public abstract boolean isRequestedSessionIdFromURL()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID came in as part of the request URL.
  Specified by:
    `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    `true` if the session ID came in as part of a URL; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromUrl

    public boolean isRequestedSessionIdFromUrl()

  Deprecated.

  Specified by:
    `isRequestedSessionIdFromUrl` in interface `HttpServletRequest`

### getHeaderNames

    public abstract java.util.Enumeration getHeaderNames()

  Description copied from interface: `HttpServletRequest`
  Returns an enumeration of all the header names this request contains. If the request has no headers, this method returns an empty enumeration.

  Some servlet containers do not allow do not allow servlets to access headers using this method, in which case this method returns `null`

  Specified by:
    `getHeaderNames` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

### getAttributeNames

    public abstract java.util.Enumeration getAttributeNames()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` containing the names of the attributes available to this request. This method returns an empty `Enumeration` if the request has no attributes available to it.
  Specified by:
    `getAttributeNames` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    an `Enumeration` of strings containing the names of the request's attributes

### getAttribute

    public abstract java.lang.Object getAttribute(java.lang.String name)

  Description copied from interface: `ServletRequest`
  Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.

  Attributes can be set two ways. The servlet container may set attributes to make available custom information about a request. For example, for requests made using HTTPS, the attribute `javax.servlet.request.X509Certificate` can be used to retrieve information on the certificate of the client. Attributes can also be set programatically using `ServletRequest.setAttribute(java.lang.String, java.lang.Object)`. This allows information to be embedded into a request before a `RequestDispatcher` call.

  Attribute names should follow the same conventions as package names. This specification reserves names matching `java.*`, `javax.*`, and `sun.*`.

  Specified by:
    `getAttribute` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute
  Returns:
    an `Object` containing the value of the attribute, or `null` if the attribute does not exist

### setAttribute

    public abstract void setAttribute(java.lang.String name,
                                      java.lang.Object value)

  Description copied from interface: `ServletRequest`
  Stores an attribute in this request. Attributes are reset between requests. This method is most often used in conjunction with `RequestDispatcher`.

  Attribute names should follow the same conventions as package names. Names beginning with `java.*`, `javax.*`, and `com.sun.*`, are reserved for use by Sun Microsystems.

  Specified by:
    `setAttribute` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute
    `o` - the `Object` to be stored

### removeAttribute

    public abstract void removeAttribute(java.lang.String name)

  Description copied from interface: `ServletRequest`
  Removes an attribute from this request. This method is not generally needed as attributes only persist as long as the request is being handled.

  Attribute names should follow the same conventions as package names. Names beginning with `java.*`, `javax.*`, and `com.sun.*`, are reserved for use by Sun Microsystems.

  Specified by:
    `removeAttribute` in interface `CauchoRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute to remove

### getParameterNames

    public abstract java.util.Enumeration getParameterNames()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request. If the request has no parameters, the method returns an empty `Enumeration`.
  Specified by:
    `getParameterNames` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    an `Enumeration` of `String` objects, each `String` containing the name of a request parameter; or an empty `Enumeration` if the request has no parameters

### getParameterValues

    public abstract java.lang.String[] getParameterValues(java.lang.String name)

  Description copied from interface: `ServletRequest`
  Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.

  If the parameter has a single value, the array has a length of 1.

  Specified by:
    `getParameterValues` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Parameters:
    `name` - a `String` containing the name of the parameter whose value is requested
  Returns:
    an array of `String` objects containing the parameter's values
  See Also:
    `ServletRequest.getParameter(java.lang.String)`

### getParameter

    public abstract java.lang.String getParameter(java.lang.String name)

  Description copied from interface: `ServletRequest`
  Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

  You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use `ServletRequest.getParameterValues(java.lang.String)`.

  If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by `getParameterValues`.

  If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via `ServletRequest.getInputStream()` or `ServletRequest.getReader()` can interfere with the execution of this method.

  Specified by:
    `getParameter` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the parameter
  Returns:
    a `String` representing the single value of the parameter
  See Also:
    `ServletRequest.getParameterValues(java.lang.String)`

### getCookies

    public abstract Cookie[] getCookies()

  Description copied from interface: `HttpServletRequest`
  Returns an array containing all of the `Cookie` objects the client sent with this request. This method returns `null` if no cookies were sent.
  Specified by:
    `getCookies` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    an array of all the `Cookies` included with this request, or `null` if the request has no cookies

### getCookie

    public abstract Cookie getCookie(java.lang.String name)

  Specified by:
    `getCookie` in interface `CauchoRequest`

### getRealPath

    public abstract java.lang.String getRealPath(java.lang.String path)

  Deprecated.

  Specified by:
    `getRealPath` in interface `ServletRequest`

### getPathTranslated

    public abstract java.lang.String getPathTranslated()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

  If the URL does not have any extra path information, this method returns `null`. The web container does not decode thins string.

  Specified by:
    `getPathTranslated` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String` specifying the real path, or `null` if the URL does not have any extra path information

### getHeaders

    public abstract java.util.Enumeration getHeaders(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns all the values of the specified request header as an `Enumeration` of `String` objects.

  Some headers, such as `Accept-Language` can be sent by clients as several headers each with a different value rather than sending the header as a comma separated list.

  If the request did not include any headers of the specified name, this method returns an empty `Enumeration`. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeaders` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

### getLocale

    public abstract java.util.Locale getLocale()

  Description copied from interface: `ServletRequest`
  Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns the default locale for the server.
  Specified by:
    `getLocale` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    the preferred `Locale` for the client

### getLocales

    public abstract java.util.Enumeration getLocales()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns an `Enumeration` containing one `Locale`, the default locale for the server.
  Specified by:
    `getLocales` in interface `ServletRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    an `Enumeration` of preferred `Locale` objects for the client

### isSecure

    public abstract boolean isSecure()

  Description copied from interface: `ServletRequest`
  Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
  Specified by:
    `isSecure` in interface `CauchoRequest`
  Following copied from interface: `javax.servlet.ServletRequest`
  Returns:
    a boolean indicating if the request was made using a secure channel

### finishSession

    protected void finishSession()
                          throws java.io.IOException

### finish

    protected void finish()
                   throws java.io.IOException

### getRequestDispatcher

    public RequestDispatcher getRequestDispatcher(java.lang.String path)

  Returns a request dispatcher relative to the current request.
  Specified by:
    `getRequestDispatcher` in interface `CauchoRequest`
  Parameters:
    `path` - the relative uri to the new servlet.

### getChain

    public java.lang.String getChain(java.lang.String contentType)

  Specified by:
    `getChain` in interface `CauchoRequest`

### getMedia

    public java.lang.String getMedia()

  Specified by:
    `getMedia` in interface `CauchoRequest`

### getAuthType

    public java.lang.String getAuthType()

  Gets the authorization type
  Specified by:
    `getAuthType` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) indicating the authentication scheme, or `null` if the request was not authenticated.

### getRemoteUser

    public java.lang.String getRemoteUser(boolean create)

  Internal logging return to get the remote user. If the request already knows the user, get it, otherwise just return null.

### authenticate

    public boolean authenticate()
                         throws ServletException,
                                java.io.IOException

### getRemoteUser

    public java.lang.String getRemoteUser()

  Gets the remote user from the authorization type
  Specified by:
    `getRemoteUser` in interface `HttpServletRequest`
  Following copied from interface: `javax.servlet.http.HttpServletRequest`
  Returns:
    a `String` specifying the login of the user making this request, or `null`

  ### getUserPrincipal

      public java.security.Principal getUserPrincipal()

    Returns the Principal representing the logged in user.
    Specified by:
      `getUserPrincipal` in interface `HttpServletRequest`
    Following copied from interface: `com.caucho.security.SecurityContextProvider`
    Returns:
      the principal in the context or null.

  ### logoutUserPrincipal

      public void logoutUserPrincipal()

    Clear the principal from the request object.

  ### isUserInRole

      public boolean isUserInRole(java.lang.String role)

    Returns true if the user represented by the current request plays the named role.
    Specified by:
      `isUserInRole` in interface `CauchoRequest`
    Parameters:
      `role` - the named role to test.
    Returns:
      true if the user plays the role.

  Overview | Package | Class | Tree | Deprecated | Index | Help
  PREV CLASS NEXT CLASS | FRAMES NO FRAMES
  SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD